# Elefant

[Elefant](http://www.elefantcms.com/) is a refreshingly simple PHP content management system and web framework.
Elefant is a fast, lean tool for building everything from simple websites to complete web applications.

<a href='http://www.pledgie.com/campaigns/16594'><img alt='Click here to lend your support to: Elefant CMS and make a donation at www.pledgie.com !' src='http://www.pledgie.com/campaigns/16594.png?skin_name=chrome' border='0' /></a>

## Built for designers

**Compiled, ultra-fast templates**

Elefant compiles your templates into secure PHP code, so rendering is as fast as possible.

**Dead simple, concise template tags**

[Familiar syntax](http://www.elefantcms.com/wiki/Templates) to other template languages, with some added conveniences for dynamic embeds and internationalization.

**Clean, easy to use site editor for your users**

Elefant comes out of the box with a [full-featured CMS](http://www.elefantcms.com/wiki/The-page-editor) for your users. You can even [white label it](http://www.elefantcms.com/wiki/White-labelling-the-CMS).

**Syntax highlighted template and CSS editor**

Sophisticated [in-browser editing](http://www.elefantcms.com/wiki/Setting-up-your-custom-designs) with highlights and references at your finger tips.

**Live preview while editing templates and CSS**

Preview in real time as you make changes. Or if you prefer, edit files directly with your editor of choice.

**Integrates with 960 grid system and jQuery**

Or any other CSS grid system, giving you complete control over your designs.

## Built for developers

**Quickly built custom apps**

With all the tools you need, and a very low learning curve, Elefant gets you writing code quickly.

**Extensively documented**

Including full [API reference](http://www.elefantcms.com/wiki/API-reference), [cheat sheets](http://www.elefantcms.com/wiki/Cheat-sheet), [tutorials, and much more](https://github.com/jbroadway/elefant/wiki/Developers).

**Strong security by default**

[Flexible input validation](http://www.elefantcms.com/wiki/Forms-and-input-validation) and automatic prevention of XSS, SQL injection, CSRF, and other types of attacks.

**Very fast and low memory**

Elefant uses [less memory per request](http://www.elefantcms.com/wiki/Performance) than any of the major frameworks, so you can serve more visitors with the same resources.

**Good debugging tools**

Debug mode prints full traces with highlighted source code and variable state to help you fix bugs faster.

**Minimalist MVC/Model2 architecture**

Elefant takes a [unique but proven approach](http://www.elefantcms.com/wiki/Elefant-architecture) that helps minimize boilerplate without sacrificing code organization as your project grows.

**Shared apps to save you time**

From blogs to user management, events to search, Elefant saves you time not reinventing the wheel with [high quality shared apps](http://www.elefantcms.com/shared-apps).

**Thoroughly unit-tested**

Elefant's core framework is covered by [extensive unit tests](https://github.com/jbroadway/elefant/tree/master/tests), ensuring a stable base to build on.

**Internationalization**

Elefant apps are automatically [i18n aware](http://www.elefantcms.com/wiki/Internationalization), with built-in multilingual capabilities and locale awareness.

## More developer goodness

Elefant builds on over 12 years of PHP experience, and aims to simplify rapid PHP development again.
As such, Elefant takes into consideration all the little details to help you work faster and better:

* Really simple, [automatic URL routing](http://www.elefantcms.com/wiki/Page-routing-and-handler-basics) w/ friendly URLs
* [Minimal but secure and fast ORM](http://www.elefantcms.com/wiki/Database-API-and-models) (based on PDO)
* Output filtering is turned *on by default*
* Tight [memcache integration](http://www.elefantcms.com/wiki/Memcache)
* Matching server- and client-side input validation
* Dead-simple [form handling](http://www.elefantcms.com/wiki/Forms-and-input-validation)
* Customizable [user authentication](http://www.elefantcms.com/wiki/Custom-user-authentication)
* [CLI tool](http://www.elefantcms.com/wiki/Command-line-usage) for common tasks
* As little scaffolding as possible
* Gzip output compression
* [Assetic](http://github.com/jbroadway/assetic) integration

## Try it out

[Download the latest release](http://www.elefantcms.com/download) or try the [online demo](http://www.elefantcms.com/demo).

* [Installation instructions](http://www.elefantcms.com/wiki/Getting-started)
* [Installing on PHP Fog](http://www.elefantcms.com/wiki/Installing-Elefant-on-PHP-Fog)
* [Installing on DotCloud](http://www.elefantcms.com/wiki/Installing-Elefant-on-DotCloud)
* [Requirements and compatible hosts](http://www.elefantcms.com/wiki/Requirements)
* [Support forum](http://www.elefantcms.com/forum/) and [support chat group](https://convore.com/elefantcms/)

## FAQ

**Q. Do you know you spelt Elephant wrong?**

A. This was my attempt at being hip and cool. No good?

**Q. Isn't Elefant a bit of an oxymoron for a slim framework?**

A. Why, yes. Yes it is.
